Code

Make write_sha1_file_prepare() void
[git.git] / git-commit.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
7 SUBDIRECTORY_OK=Yes
8 . git-sh-setup
10 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
11 branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)
13 case "$0" in
14 *status)
15         status_only=t
16         unmerged_ok_if_status=--unmerged ;;
17 *commit)
18         status_only=
19         unmerged_ok_if_status= ;;
20 esac
22 refuse_partial () {
23         echo >&2 "$1"
24         echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
25         exit 1
26 }
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
30 rm -f "$NEXT_INDEX"
31 save_index () {
32         cp -p "$THIS_INDEX" "$NEXT_INDEX"
33 }
35 run_status () {
36         # If TMP_INDEX is defined, that means we are doing
37         # "--only" partial commit, and that index file is used
38         # to build the tree for the commit.  Otherwise, if
39         # NEXT_INDEX exists, that is the index file used to
40         # make the commit.  Otherwise we are using as-is commit
41         # so the regular index file is what we use to compare.
42         if test '' != "$TMP_INDEX"
43         then
44                 GIT_INDEX_FILE="$TMP_INDEX"
45                 export GIT_INDEX_FILE
46         elif test -f "$NEXT_INDEX"
47         then
48                 GIT_INDEX_FILE="$NEXT_INDEX"
49                 export GIT_INDEX_FILE
50         fi
52         case "$status_only" in
53         t) color= ;;
54         *) color=--nocolor ;;
55         esac
56         git-runstatus ${color} \
57                 ${verbose:+--verbose} \
58                 ${amend:+--amend} \
59                 ${untracked_files:+--untracked}
60 }
62 trap '
63         test -z "$TMP_INDEX" || {
64                 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
65         }
66         rm -f "$NEXT_INDEX"
67 ' 0
69 ################################################################
70 # Command line argument parsing and sanity checking
72 all=
73 also=
74 only=
75 logfile=
76 use_commit=
77 amend=
78 edit_flag=
79 no_edit=
80 log_given=
81 log_message=
82 verify=t
83 verbose=
84 signoff=
85 force_author=
86 only_include_assumed=
87 untracked_files=
88 while case "$#" in 0) break;; esac
89 do
90         case "$1" in
91         -F|--F|-f|--f|--fi|--fil|--file)
92                 case "$#" in 1) usage ;; esac
93                 shift
94                 no_edit=t
95                 log_given=t$log_given
96                 logfile="$1"
97                 shift
98                 ;;
99         -F*|-f*)
100                 no_edit=t
101                 log_given=t$log_given
102                 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
103                 shift
104                 ;;
105         --F=*|--f=*|--fi=*|--fil=*|--file=*)
106                 no_edit=t
107                 log_given=t$log_given
108                 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
109                 shift
110                 ;;
111         -a|--a|--al|--all)
112                 all=t
113                 shift
114                 ;;
115         --au=*|--aut=*|--auth=*|--autho=*|--author=*)
116                 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
117                 shift
118                 ;;
119         --au|--aut|--auth|--autho|--author)
120                 case "$#" in 1) usage ;; esac
121                 shift
122                 force_author="$1"
123                 shift
124                 ;;
125         -e|--e|--ed|--edi|--edit)
126                 edit_flag=t
127                 shift
128                 ;;
129         -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
130                 also=t
131                 shift
132                 ;;
133         -o|--o|--on|--onl|--only)
134                 only=t
135                 shift
136                 ;;
137         -m|--m|--me|--mes|--mess|--messa|--messag|--message)
138                 case "$#" in 1) usage ;; esac
139                 shift
140                 log_given=m$log_given
141                 if test "$log_message" = ''
142                 then
143                     log_message="$1"
144                 else
145                     log_message="$log_message
147 $1"
148                 fi
149                 no_edit=t
150                 shift
151                 ;;
152         -m*)
153                 log_given=m$log_given
154                 if test "$log_message" = ''
155                 then
156                     log_message=`expr "z$1" : 'z-m\(.*\)'`
157                 else
158                     log_message="$log_message
160 `expr "z$1" : 'z-m\(.*\)'`"
161                 fi
162                 no_edit=t
163                 shift
164                 ;;
165         --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
166                 log_given=m$log_given
167                 if test "$log_message" = ''
168                 then
169                     log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
170                 else
171                     log_message="$log_message
173 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
174                 fi
175                 no_edit=t
176                 shift
177                 ;;
178         -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
179         --no-verify)
180                 verify=
181                 shift
182                 ;;
183         --a|--am|--ame|--amen|--amend)
184                 amend=t
185                 log_given=t$log_given
186                 use_commit=HEAD
187                 shift
188                 ;;
189         -c)
190                 case "$#" in 1) usage ;; esac
191                 shift
192                 log_given=t$log_given
193                 use_commit="$1"
194                 no_edit=
195                 shift
196                 ;;
197         --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
198         --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
199         --reedit-messag=*|--reedit-message=*)
200                 log_given=t$log_given
201                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
202                 no_edit=
203                 shift
204                 ;;
205         --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
206         --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
207         --reedit-message)
208                 case "$#" in 1) usage ;; esac
209                 shift
210                 log_given=t$log_given
211                 use_commit="$1"
212                 no_edit=
213                 shift
214                 ;;
215         -C)
216                 case "$#" in 1) usage ;; esac
217                 shift
218                 log_given=t$log_given
219                 use_commit="$1"
220                 no_edit=t
221                 shift
222                 ;;
223         --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
224         --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
225         --reuse-message=*)
226                 log_given=t$log_given
227                 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
228                 no_edit=t
229                 shift
230                 ;;
231         --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
232         --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
233                 case "$#" in 1) usage ;; esac
234                 shift
235                 log_given=t$log_given
236                 use_commit="$1"
237                 no_edit=t
238                 shift
239                 ;;
240         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
241                 signoff=t
242                 shift
243                 ;;
244         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
245                 verbose=t
246                 shift
247                 ;;
248         -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
249         --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
250         --untracked-file|--untracked-files)
251                 untracked_files=t
252                 shift
253                 ;;
254         --)
255                 shift
256                 break
257                 ;;
258         -*)
259                 usage
260                 ;;
261         *)
262                 break
263                 ;;
264         esac
265 done
266 case "$edit_flag" in t) no_edit= ;; esac
268 ################################################################
269 # Sanity check options
271 case "$amend,$initial_commit" in
272 t,t)
273         die "You do not have anything to amend." ;;
274 t,)
275         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
276                 die "You are in the middle of a merge -- cannot amend."
277         fi ;;
278 esac
280 case "$log_given" in
281 tt*)
282         die "Only one of -c/-C/-F can be used." ;;
283 *tm*|*mt*)
284         die "Option -m cannot be combined with -c/-C/-F." ;;
285 esac
287 case "$#,$also,$only,$amend" in
288 *,t,t,*)
289         die "Only one of --include/--only can be used." ;;
290 0,t,,* | 0,,t,)
291         die "No paths with --include/--only does not make sense." ;;
292 0,,t,t)
293         only_include_assumed="# Clever... amending the last one with dirty index." ;;
294 0,,,*)
295         ;;
296 *,,,*)
297         only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
298         also=
299         ;;
300 esac
301 unset only
302 case "$all,$also,$#" in
303 t,t,*)
304         die "Cannot use -a and -i at the same time." ;;
305 t,,[1-9]*)
306         die "Paths with -a does not make sense." ;;
307 ,t,0)
308         die "No paths with -i does not make sense." ;;
309 esac
311 ################################################################
312 # Prepare index to have a tree to be committed
314 TOP=`git-rev-parse --show-cdup`
315 if test -z "$TOP"
316 then
317         TOP=./
318 fi
320 case "$all,$also" in
321 t,)
322         save_index &&
323         (
324                 cd "$TOP"
325                 GIT_INDEX_FILE="$NEXT_INDEX"
326                 export GIT_INDEX_FILE
327                 git-diff-files --name-only -z |
328                 git-update-index --remove -z --stdin
329         )
330         ;;
331 ,t)
332         save_index &&
333         git-ls-files --error-unmatch -- "$@" >/dev/null || exit
335         git-diff-files --name-only -z -- "$@"  |
336         (
337                 cd "$TOP"
338                 GIT_INDEX_FILE="$NEXT_INDEX"
339                 export GIT_INDEX_FILE
340                 git-update-index --remove -z --stdin
341         )
342         ;;
343 ,)
344         case "$#" in
345         0)
346                 ;; # commit as-is
347         *)
348                 if test -f "$GIT_DIR/MERGE_HEAD"
349                 then
350                         refuse_partial "Cannot do a partial commit during a merge."
351                 fi
352                 TMP_INDEX="$GIT_DIR/tmp-index$$"
353                 if test -z "$initial_commit"
354                 then
355                         # make sure index is clean at the specified paths, or
356                         # they are additions.
357                         dirty_in_index=`git-diff-index --cached --name-status \
358                                 --diff-filter=DMTU HEAD -- "$@"`
359                         test -z "$dirty_in_index" ||
360                         refuse_partial "Different in index and the last commit:
361 $dirty_in_index"
362                 fi
363                 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
365                 # Build the temporary index and update the real index
366                 # the same way.
367                 if test -z "$initial_commit"
368                 then
369                         cp "$THIS_INDEX" "$TMP_INDEX"
370                         GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
371                 else
372                         rm -f "$TMP_INDEX"
373                 fi || exit
375                 echo "$commit_only" |
376                 GIT_INDEX_FILE="$TMP_INDEX" \
377                 git-update-index --add --remove --stdin &&
379                 save_index &&
380                 echo "$commit_only" |
381                 (
382                         GIT_INDEX_FILE="$NEXT_INDEX"
383                         export GIT_INDEX_FILE
384                         git-update-index --remove --stdin
385                 ) || exit
386                 ;;
387         esac
388         ;;
389 esac
391 ################################################################
392 # If we do as-is commit, the index file will be THIS_INDEX,
393 # otherwise NEXT_INDEX after we make this commit.  We leave
394 # the index as is if we abort.
396 if test -f "$NEXT_INDEX"
397 then
398         USE_INDEX="$NEXT_INDEX"
399 else
400         USE_INDEX="$THIS_INDEX"
401 fi
403 GIT_INDEX_FILE="$USE_INDEX" \
404         git-update-index -q $unmerged_ok_if_status --refresh || exit
406 ################################################################
407 # If the request is status, just show it and exit.
409 case "$0" in
410 *status)
411         run_status
412         exit $?
413 esac
415 ################################################################
416 # Grab commit message, write out tree and make commit.
418 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
419 then
420         if test "$TMP_INDEX"
421         then
422                 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
423         else
424                 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
425         fi || exit
426 fi
428 if test "$log_message" != ''
429 then
430         echo "$log_message"
431 elif test "$logfile" != ""
432 then
433         if test "$logfile" = -
434         then
435                 test -t 0 &&
436                 echo >&2 "(reading log message from standard input)"
437                 cat
438         else
439                 cat <"$logfile"
440         fi
441 elif test "$use_commit" != ""
442 then
443         git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
444 elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
445 then
446         cat "$GIT_DIR/MERGE_MSG"
447 elif test -f "$GIT_DIR/SQUASH_MSG"
448 then
449         cat "$GIT_DIR/SQUASH_MSG"
450 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
452 case "$signoff" in
453 t)
454         {
455                 echo
456                 git-var GIT_COMMITTER_IDENT | sed -e '
457                         s/>.*/>/
458                         s/^/Signed-off-by: /
459                 '
460         } >>"$GIT_DIR"/COMMIT_EDITMSG
461         ;;
462 esac
464 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
465         echo "#"
466         echo "# It looks like you may be committing a MERGE."
467         echo "# If this is not correct, please remove the file"
468         echo "# $GIT_DIR/MERGE_HEAD"
469         echo "# and try again"
470         echo "#"
471 fi >>"$GIT_DIR"/COMMIT_EDITMSG
473 # Author
474 if test '' != "$force_author"
475 then
476         GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
477         GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
478         test '' != "$GIT_AUTHOR_NAME" &&
479         test '' != "$GIT_AUTHOR_EMAIL" ||
480         die "malformed --author parameter"
481         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
482 elif test '' != "$use_commit"
483 then
484         pick_author_script='
485         /^author /{
486                 s/'\''/'\''\\'\'\''/g
487                 h
488                 s/^author \([^<]*\) <[^>]*> .*$/\1/
489                 s/'\''/'\''\'\'\''/g
490                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
492                 g
493                 s/^author [^<]* <\([^>]*\)> .*$/\1/
494                 s/'\''/'\''\'\'\''/g
495                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
497                 g
498                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
499                 s/'\''/'\''\'\'\''/g
500                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
502                 q
503         }
504         '
505         set_author_env=`git-cat-file commit "$use_commit" |
506         LANG=C LC_ALL=C sed -ne "$pick_author_script"`
507         eval "$set_author_env"
508         export GIT_AUTHOR_NAME
509         export GIT_AUTHOR_EMAIL
510         export GIT_AUTHOR_DATE
511 fi
513 PARENTS="-p HEAD"
514 if test -z "$initial_commit"
515 then
516         rloga='commit'
517         if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
518                 rloga='commit (merge)'
519                 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
520         elif test -n "$amend"; then
521                 rloga='commit (amend)'
522                 PARENTS=$(git-cat-file commit HEAD |
523                         sed -n -e '/^$/q' -e 's/^parent /-p /p')
524         fi
525         current=$(git-rev-parse --verify HEAD)
526 else
527         if [ -z "$(git-ls-files)" ]; then
528                 echo >&2 Nothing to commit
529                 exit 1
530         fi
531         PARENTS=""
532         current=
533         rloga='commit (initial)'
534 fi
536 if test -z "$no_edit"
537 then
538         {
539                 echo ""
540                 echo "# Please enter the commit message for your changes."
541                 echo "# (Comment lines starting with '#' will not be included)"
542                 test -z "$only_include_assumed" || echo "$only_include_assumed"
543                 run_status
544         } >>"$GIT_DIR"/COMMIT_EDITMSG
545 else
546         # we need to check if there is anything to commit
547         run_status >/dev/null 
548 fi
549 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
550 then
551         rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
552         run_status
553         exit 1
554 fi
556 case "$no_edit" in
557 '')
558         case "${VISUAL:-$EDITOR},$TERM" in
559         ,dumb)
560                 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
561                 echo >&2 "Please supply the commit log message using either"
562                 echo >&2 "-m or -F option.  A boilerplate log message has"
563                 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
564                 exit 1
565                 ;;
566         esac
567         git-var GIT_AUTHOR_IDENT > /dev/null  || die
568         git-var GIT_COMMITTER_IDENT > /dev/null  || die
569         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
570         ;;
571 esac
573 case "$verify" in
574 t)
575         if test -x "$GIT_DIR"/hooks/commit-msg
576         then
577                 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
578         fi
579 esac
581 if test -z "$no_edit"
582 then
583     sed -e '
584         /^diff --git a\/.*/{
585             s///
586             q
587         }
588         /^#/d
589     ' "$GIT_DIR"/COMMIT_EDITMSG
590 else
591     cat "$GIT_DIR"/COMMIT_EDITMSG
592 fi |
593 git-stripspace >"$GIT_DIR"/COMMIT_MSG
595 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
596         git-stripspace |
597         wc -l` &&
598    test 0 -lt $cnt
599 then
600         if test -z "$TMP_INDEX"
601         then
602                 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
603         else
604                 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
605                 rm -f "$TMP_INDEX"
606         fi &&
607         commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
608         rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
609         git-update-ref -m "$rloga: $rlogm" HEAD $commit $current &&
610         rm -f -- "$GIT_DIR/MERGE_HEAD" &&
611         if test -f "$NEXT_INDEX"
612         then
613                 mv "$NEXT_INDEX" "$THIS_INDEX"
614         else
615                 : ;# happy
616         fi
617 else
618         echo >&2 "* no commit message?  aborting commit."
619         false
620 fi
621 ret="$?"
622 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
623 if test -d "$GIT_DIR/rr-cache"
624 then
625         git-rerere
626 fi
628 if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
629 then
630         "$GIT_DIR"/hooks/post-commit
631 fi
632 exit "$ret"